package dao

import (
	"contract_backend/model"
	"encoding/json"

	"gorm.io/gorm"
	"gorm.io/gorm/logger"
)

func (d *Dao) UpdateTask(id string, txHash string, status int) (err error) {
	sql := `UPDATE public.exec_task SET tx_hash = ?, tx_status = ? WHERE id = ?`
	return d.db.Exec(sql, txHash, status, id).Error
}

func (d *Dao) GetUnprocessedTasks(limit int) (tasks []*model.ExecTask, err error) {
	sql := `SELECT id, user_id, app_key, model_ids, tx_hash, tx_status FROM public.exec_task WHERE tx_hash = '' AND tx_status = 1 LIMIT ?`
	tx := d.db.Session(&gorm.Session{Logger: d.db.Logger.LogMode(logger.Error)})
	err = tx.Raw(sql, limit).Scan(&tasks).Error
	if err != nil {
		return
	}
	for i := 0; i < len(tasks); i++ {
		err = json.Unmarshal(tasks[i].ModelIds, &tasks[i].ModelIdsArray)
		if err != nil {
			return
		}
	}
	return
}
