package dao

import (
	"context"
	"contract_backend/contract/aon_user"
	"encoding/base64"
	"testing"

	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/ethclient"
	"github.com/google/uuid"
)

func TestUID(t *testing.T) {
	b, _ := base64.StdEncoding.DecodeString("9jS2xPA3kAyM2F7yvSRi3WwAgDU7sXEPgHEIrR6RhckA")
	u, _ := uuid.ParseBytes(b)
	t.Log(u.String())
}

func TestLogin(t *testing.T) {
	cli, _ := ethclient.Dial("https://opbnb-testnet-rpc.bnbchain.org")
	instance, _ := aon_user.NewAonUser(common.HexToAddress("0xb50e74f8903bb72b3bff13c37ccc9114336102d1"), cli)

	rec, _ := cli.TransactionReceipt(context.Background(), common.HexToHash("0xac2d1b1db3045665770aa63ea1df4672a333cef3c50788ee5df47e27036de6e4"))

	lg, _ := instance.ParseRegister(*rec.Logs[2])
	t.Log(lg.UserName)

}
