CREATE
OR REPLACE FUNCTION auth.userChange () RETURNS TRIGGER SECURITY definer AS $$
BEGIN
 IF new.last_sign_in_at IS NOT NULL OR old.last_sign_in_at IS NOT NULL THEN
    perform "net"."http_post"(
      url := 'http://webhook.atqg.top/webhook/handleUserChange'::text,
      body := jsonb_build_object(
        'old_row', jsonb_build_object(
          'id', old.id,
          'last_sign_in_at', old.last_sign_in_at
        ),
        'new_row', jsonb_build_object(
          'id', new.id,
          'last_sign_in_at', new.last_sign_in_at
        ),
        'table', TG_TABLE_NAME,
        'operation', TG_OP
      ),
      headers:='{"Content-Type": "application/json"}'::jsonb
    ) as request_id;
  END IF;
RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE
OR REPLACE TRIGGER userChange
AFTER
UPDATE ON auth.users FOR EACH ROW
EXECUTE FUNCTION auth.userChange();



CREATE
OR REPLACE FUNCTION public.taskChange () RETURNS TRIGGER SECURITY definer AS $$
BEGIN
    perform "net"."http_post"(
      url := 'http://webhook.atqg.top/webhook/handleTaskChange'::text,
      body := jsonb_build_object(
        'old_row', jsonb_build_object(
          'id', old.id,
          'user_id', old.user_id,
          'app_key', old.app_key,
          'model_ids', old.model_ids,
          'status', old.status,
          'tx_hash', old.tx_hash,
          'tx_status', old.tx_status
        ),
        'new_row', jsonb_build_object(
          'id', new.id,
          'user_id', new.user_id,
          'app_key', new.app_key,
          'model_ids', new.model_ids,
          'status', new.status,
          'tx_hash', new.tx_hash,
          'tx_status', new.tx_status
        ),
        'table', TG_TABLE_NAME,
        'operation', TG_OP
      ),
      headers:='{"Content-Type": "application/json"}'::jsonb
    ) as request_id;
  RETURN NEW;
END;
$$ LANGUAGE plpgsql;


CREATE OR REPLACE FUNCTION public.taskChange()
RETURNS TRIGGER
SECURITY DEFINER AS $$
BEGIN
    -- 只在状态从0变为1时执行
    IF (TG_OP = 'UPDATE' AND OLD.status = 0 AND NEW.status = 1) THEN
        UPDATE public.exec_task SET tx_status = 1 WHERE id = NEW.id;
    END IF;

    RETURN NEW;
END;
$$ LANGUAGE plpgsql;


CREATE
OR REPLACE TRIGGER taskChange
AFTER UPDATE  ON public.exec_task FOR EACH ROW
EXECUTE FUNCTION public.taskChange();
